<script setup>
import { ref, computed, onMounted, onUpdated} from 'vue';
import Profile from '../../modules/profile';
import { appEvents, gameEvents } from '../../events';
import Info from './charinfo.vue';
import Upgrades from './hall_upgrades.vue';
import { centerXY } from '../popups/popups';
import { EVT_STAT } from '../../events';
import { formatNumber } from '../../util/format';
import Confirm from '../components/confirm.vue';

/**
 * Hall of Wizards
 *
 * @emits set-char
 * @emits dismiss-char
 * @emits close
 */

const emits = defineEmits(['close'])

const elRef = ref();

//const chars = ref(Profile.hall.chars);
const hName = ref(Profile.hall.name);

onMounted(() => {
	centerXY(elRef.value);
});
onUpdated(() => {
	centerXY(elRef.value);
});


const load = (slot) => {

	emits('close');
	appEvents.emit('set-char', slot);

}

const dismiss = (slot, name) => {

	gameEvents.emit('warn', `Dismiss ${name}`, () => {

		appEvents.emit('dismiss-char', slot);

	});

}

const warnDone = (okay, slot) => {
	if (okay) appEvents.emit('set-char', slot);
}

const hall = computed(() => { return Profile.hall; });

const availChars = computed(() => {
	return Profile.hall.getChars();
});

const prestige = computed(() => {

	const p = hall.value.prestige.valueOf();

	appEvents.emit(EVT_STAT, 'prestige', p);

	return p;

});

const hallName = computed({
	get() { return hName.value; },
	set(v) {
		if (v) Profile.setHallName(v);
		hName.value = v;
	}
});

</script>

<template>

<div class="popup wizhall" ref="elRef">

	<div class="power" @mouseenter.capture.stop="itemOver($event, hall.prestige)">Hall Prestige: {{ formatNumber(prestige) }}</div>

	<div class="header"><input class="fld-name text-entry" type="text" v-model="hallName">
			<div class="text-button"><a href=""
			@click.self.prevent="appEvents.emit('hall-file', $event)" type="text/json">Hall Save</a></div>

			<Confirm @confirm="appEvents.emit('resetHall')">Wipe Hall Save</Confirm>

			</div>


	<div class="chars">
	<Info v-for="(c, i) in availChars" :char="c" :active="i == hall.curSlot"
		:key="i" @load="load(i)" @dismiss="dismiss(i, c.name)" />
	</div>

	<Upgrades :items="hall.upgrades" />

	<div class="popup-close" @click="emits('close')">X</div>

</div>

</template>

<style scoped>
div.wizhall {
	z-index: 5000;
	min-width: 40vw;
	max-width: 80vw;
	max-height: 90vh;
	padding: var(--rg-gap);
	overflow: auto;

}

div.header {
	display: flex;
	justify-content: center;
	margin: var(--md-gap);
}

div.wizhall .upgrades {
	display: flex;
	flex-flow: row wrap;
}

div.wizhall div.power {
	position: absolute;
	top: var(--lg-gap);
	left: var(--lg-gap);
	font-size: 0.94em;
}

div.header .fld-name {
	text-align: center;
	font-size: 1.4em;
}


div.wizhall .chars {
	display: flex;
	flex-flow: row wrap;
	justify-content: space-evenly;
}
</style>
